#!/usr/bin/env python
import os,sys
from datetime import datetime
import config
sys.path.insert(0,"/home/ubuntu/python/ffcms/")
from base import bd_sql
def get_id_path(_path):
	meta={}
	meta['path']=_path
	sql="""select id from path where path='%(path)s'"""%meta
	if bd_sql.execute(sql,hist=0):
		id=bd_sql.get_row(0)[0][0]
		return id
	else:
		isql="""insert into path (date,path,md5) values(now(),'%(path)s',md5('%(path)s'))"""%meta
		if bd_sql.execute(isql,hist=0):
			sql="""select id from path where path='%(path)s'"""%meta
			if bd_sql.execute(sql,hist=0):
				id=bd_sql.get_row(0)[0][0]
				return id
	return 0
ext={}
def get_id_ext(_ext):
	_ext=_ext.lower()
	if ext.has_key(_ext):
		return ext[_ext]
	meta={}
	meta['ext']=_ext
	sql="""select id from ext where ext='%(ext)s'"""%meta
	if bd_sql.execute(sql,hist=0):
		id=bd_sql.get_row(0)[0][0]
		ext[meta['ext']]=id
#		print "ext add:%s"%_ext
		return id
	else:
		isql="""insert into ext (date,ext) values(now(),'%(ext)s')"""%meta
		if bd_sql.execute(isql,hist=0):
			sql="""select id from ext where ext='%(ext)s'"""%meta
			if bd_sql.execute(sql,hist=0):
				id=bd_sql.get_row(0)[0][0]
				ext[meta['ext']]=id
				return id
	return 0
def index_file(file):
	pt=os.path.split(file)
	if bd_sql.execute( """select id from files where file='%s' and id_path='%d'"""%(pt[1],get_id_path(pt[0])) ) :
		return
	if os.path.exists(file):
		meta={}
		meta['path']=os.path.split(file)[0]
		meta['file']=os.path.split(file)[1]
		eext=meta['file'].split('.')
		if len(eext)>1:meta['ext'] = eext[-1]
		else: meta['ext'] = ''
		meta['size']=os.path.getsize(file)
		meta['atime'] = datetime.fromtimestamp(os.path.getatime(file))
		meta['ctime'] = datetime.fromtimestamp(os.path.getctime(file))
		meta['mtime'] = datetime.fromtimestamp(os.path.getmtime(file))
		sql="""select id from path where path='%(path)s'"""%meta
		idp=get_id_path(meta['path'])
		if idp:
			meta['id_path']=idp
		else:
			return
		ide=get_id_ext(meta['ext'])
		if ide:
			meta['id_ext']=ide
		else:
			return
		sql="""select id from files where file='%(file)s' and id_path='%(id_path)d'"""%meta
		if bd_sql.execute(sql) == 0:
			isql="""insert into files (date,md5,id_path,file,id_ext,size,atime,ctime,mtime) values(now(),md5('%(file)s'),'%(id_path)d','%(file)s','%(id_ext)d','%(size)d','%(atime)s','%(ctime)s','%(mtime)s')"""%meta
			if bd_sql.execute(isql,hist=0):
#				print "Ok: ",file
				return
#		print """already""",file
	else:
		print "error file '%s'"%file


def index_file2(str):
	meta={}
	ff=str.split(" ")
	meta["size"]=ff[0]
	meta["ctime"]=" ".join(ff[1:3])
	file=" ".join(ff[3:])#.replace("'","\\'")
	meta["path"]=os.path.split(file)[0]
	meta["file"]=os.path.split(file)[1]
	idp=get_id_path(meta['path'])
	if idp:
		meta['id_path']=idp
	else:
		return
	ex=meta["file"].split('.')
	if len(ex)>1:meta['ext'] = ex[-1]
	else: meta['ext'] = ''
	ide=get_id_ext(meta['ext'])
	if ide:
		meta['id_ext']=ide
	else:
		return
#sql="""select id from files where file='%(file)s' and id_path='%(id_path)d'"""%meta
#if bd_sql.execute(sql) == 0:
	isql="""insert into files (date,md5,id_path,file,id_ext,size,ctime) values(now(),md5('%(file)s'),'%(id_path)d','%(file)s','%(id_ext)d','%(size)s','%(ctime)s');"""%meta
	return isql+"\n"
#		if bd_sql.execute(isql,hist=0):
#			pass
		#	print "Ok: ",file

import time
def p_t(s=0):
	t=time.mktime(time.localtime())
	if s:
		print t-s	
	return t

	
if __name__ == '__main__':
	if len(sys.argv)>1:
		os.system('mysql -h localhost -u root < delete_tests_sql.sql ')
		os.system('mysql -h localhost -u root < create_tests_sql.sql ')
		ts=0
		ts=p_t(ts)
		print "parsing txt"
		file=open("ftp.sql","w")
		file.write("set names utf8;\n")
		for str in open(sys.argv[1]).readlines():
			sql=index_file2(str.replace("\n",""))
			if sql:
				file.write(sql)
		ts=p_t(ts)
		print "import mysql"
		os.system('mysql -h localhost -u root test_mysql < ftp.sql')
		ts=p_t(ts)
		print "make mysql index"
		os.system('mysql -h localhost -u root test_mysql < make_index.sql')
		ts=p_t(ts)
	else:
		print "no input file"
